﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace LeakyBucketTest {
	public partial class Form1 : Form {
		LeakyBucket quota = new LeakyBucket();
		public Form1() {
			InitializeComponent();
			quota.Value       = 0;
			quota.MaxQuota    = 10;
			quota.RestoreRate = 3000;
		}

		//------------------------------------------------
		// 開始時の処理
		//------------------------------------------------
		private void BtnStart_Click( object sender, EventArgs e ) {

			// 画面の状態を変更
			BtnStart.Enabled = false;
			BtnStop.Enabled  = true;
			BtnAdd.Enabled   = true;
			EdtMaxQuota.ReadOnly    = true;
			EdtRestoreRate.ReadOnly = true;

			// 初期値のセット
			quota.Value       = ToIntDef( EdtCurQuota.Text, 0 );
			quota.MaxQuota    = ToIntDef( EdtMaxQuota.Text, 10 );
			quota.RestoreRate = ToIntDef( EdtRestoreRate.Text, 1000 );

			timer1.Enabled = true;
		}

		//------------------------------------------------
		// 終了時の処理
		//------------------------------------------------
		private void BtnStop_Click( object sender, EventArgs e ) {
			BtnStart.Enabled = true;
			BtnStop.Enabled  = false;
			BtnAdd.Enabled   = false;
			EdtMaxQuota.ReadOnly    = false;
			EdtRestoreRate.ReadOnly = false;

			timer1.Enabled = false;
		}

		//------------------------------------------------
		// 加算処理
		//------------------------------------------------
		private void BtnAdd_Click( object sender, EventArgs e ) {
			if ( quota.MaxQuota <= quota.Value ) {
				return;
			}
			quota.Value++;

		}

		//------------------------------------------------
		// LeakyBucketの状態表示タイマー(開始時のみ有効)
		//------------------------------------------------
		private void timer1_Tick( object sender, EventArgs e ) {
			EdtCurQuota.Text    = quota.Value.ToString();
			EdtMaxQuota.Text    = quota.MaxQuota.ToString();
			EdtRestoreRate.Text = quota.RestoreRate.ToString();
		}


		//------------------------------------------------
		// 文字列を数値に変換する
		//------------------------------------------------
		private int ToIntDef( string inStr, int defaultValue ) {
			try {
				return Int32.Parse( inStr );
			} catch {
				return defaultValue;
			}
		}
	}

}
